#pragma once

#include "NPCommonUI.h"
#include "DrawingShape.h"
#include <atlstr.h>
#include <Richedit.h>
#include "ScriptletContainerFactory.h"

//{kr} Vertical Alignment {/kr}
#define PFA_TOP				 (32)
#define PFA_BOTTOM			 (33)
#define PFA_VCENTER			 (34)

/**
* @ingroup 	CommonUI	
* @brief 	{kr} ܼ ؽƮ  {/kr}
* @date		06/29/2007
* @author	telltale
* @remark	
*/
class NPCOMMONUI_API CSimpleTextShape : public CDrawingShape
{
public:
	DECLARE_COMPONENT_CREATOR(CSimpleTextShape);
	CSimpleTextShape(void);
	virtual ~CSimpleTextShape(void);
	DECLARE_RTTI;

//override
	//CComponent
	LPCTSTR GetClassName() { return SCRIPTLET_SIMPLETEXT_NODE; }
	void DrawComponent(HDC hDC);
	// {kr} ؽƮ ԷµǾ best fit  size . {/kr}
	BOOL GetOrginPreferredSize(LPSIZE lpSize);

//operation
	BOOL GetTextPreferredSize(LPSIZE lpSize);
	//{kr} ؽƮ  {/kr}
	virtual void SetText(LPCTSTR pszcText);
	LPCTSTR GetText() { return m_strText; }

	//{kr}   {/kr}
	void SetCharFormat(CHARFORMAT2& cf);
	CHARFORMAT2 GetCharFormat() { return m_cf; }
	//{kr}   {/kr}
	void SetParaFormat(PARAFORMAT2& pf);
	PARAFORMAT2 GetParaFormat() { return m_pf; }
	
	//{kr} ۲  {/kr}
	void SetFontName(LPCTSTR pszcFontName, BYTE bCharset);
	LPCTSTR GetFontname();
	BYTE GetCharset();
	//{kr} ũ(point)  {/kr}
	void SetFontSize(int nFontSize);
	int GetFontSize();
	//{kr} ڻ  {/kr}
	void SetFontColor(COLORREF clrFont);
	COLORREF GetFontColor();
	//{kr}   {/kr}
	void SetBackground(COLORREF clrBack);
	COLORREF GetBackground();
	void SetUnderline( BOOL bUnderLine );
	//{kr} BOLD  {/kr}
	void SetBold(BOOL bBold);
	BOOL IsBold();
	//{kr} ITALIC  {/kr}
	void SetItalic(BOOL bItalic);
	BOOL IsItalic();
	//{kr} ܰ  {/kr}
	void SetOutline(BOOL bOutline);
	BOOL IsOutline();

	//{kr} Vertical Alignment {/kr}
	void SetVAlign(int nAlign);
	int GetVAlign();
	//{kr} Horizontal Alignment {/kr}
	void SetHAlign(int nAlign);
	int GetHAlign();

	void SetEnableWordbreak() { m_bWordbreak = TRUE; }

	void SetTrimming(BOOL bTrimming){ m_bTrimming = bTrimming; }

protected:
	static void SetFlag(BOOL bValue, DWORD& dwValue, DWORD dwFlag)
	{
		if (bValue)
		{
			dwValue |= dwFlag;
		}
		else
		{
			dwValue &= ~dwFlag;
		}
	}
	static BOOL GetFlag(DWORD dwValue, DWORD dwFlag)
	{
		return (dwValue & dwFlag ) != 0;
	}

	CString m_strText;
	CHARFORMAT2	m_cf;
	PARAFORMAT2 m_pf;
	int m_nVAlign;
	BOOL m_bWordbreak;
	BOOL m_bTrimming; // ... ?
};
